# keycloak_group – Allows administration of Keycloak groups via Keycloak API

New in version 2.8.

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module allows you to add, remove or modify Keycloak groups via the Keycloak REST API. It requires access to the REST API via OpenID Connect; the user connecting and the client being used must have the requisite access rights. In a default Keycloak installation, admin-cli and an admin user would work, as would a separate client definition with the scope tailored to your needs and a user having the expected roles.
- The names of module options are snake_cased versions of the camelCase ones found in the Keycloak API and its documentation at http://www.keycloak.org/docs-api/3.3/rest-api/.
- Attributes are multi-valued in the Keycloak API. All attributes are lists of individual values and will be returned that way by this module. You may pass single values for attributes when calling the module, and this will be translated into a list suitable for the API.
- When updating a group, where possible provide the group ID to the module. This removes a lookup to the API to translate the name into the group ID.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
attributes dictionary |  | A dict of key/value pairs to set as custom attributes for the group. Values may be single values (e.g. a string) or a list of strings.
auth_client_id string / required | Default: "admin-cli" | OpenID Connect client_id to authenticate to the API with.
auth_client_secret string |  | Client Secret to use in conjunction with auth_client_id (if required).
auth_keycloak_url string / required |  | URL to the Keycloak instance. aliases: url
auth_password string / required |  | Password to authenticate for API access with. aliases: password
auth_realm string / required |  | Keycloak realm name to authenticate to for API access.
auth_username string / required |  | Username to authenticate for API access with. aliases: username
id string |  | The unique identifier for this group. This parameter is not required for updating or deleting a group but providing it will reduce the number of API calls required.
name string |  | Name of the group. This parameter is required only when creating or updating the group.
realm string | Default: "master" | They Keycloak realm under which this group resides.

state
string / required

Choices:
- present ←
- absent

State of the group.
On `present`, the group will be created if it does not yet exist, or updated with the parameters you provide.
On `absent`, the group will be removed if it exists.

validate_certs
boolean

Choices:
- no
- yes ←

Verify TLS certificates (do not disable this in production).

## Notes

Note

- Presently, the realmRoles, clientRoles and access attributes returned by the Keycloak API are read-only for groups. This limitation will be removed in a later version of this module.

## Examples

    - name: Create a Keycloak group
      keycloak_group:
        name: my-new-kc-group
        realm: MyCustomRealm
        state: present
        auth_client_id: admin-cli
        auth_keycloak_url: https://auth.example.com/auth
        auth_realm: master
        auth_username: USERNAME
        auth_password: PASSWORD
      delegate_to: localhost

    - name: Delete a keycloak group
      keycloak_group:
        id: '9d59aa76-2755-48c6-b1af-beb70a82c3cd'
        state: absent
        realm: MyCustomRealm
        auth_client_id: admin-cli
        auth_keycloak_url: https://auth.example.com/auth
        auth_realm: master
        auth_username: USERNAME
        auth_password: PASSWORD
      delegate_to: localhost

    - name: Delete a Keycloak group based on name
      keycloak_group:
        name: my-group-for-deletion
        state: absent
        auth_client_id: admin-cli
        auth_keycloak_url: https://auth.example.com/auth
        auth_realm: master
        auth_username: USERNAME
        auth_password: PASSWORD
      delegate_to: localhost

    - name: Update the name of a Keycloak group
      keycloak_group:
        id: '9d59aa76-2755-48c6-b1af-beb70a82c3cd'
        name: an-updated-kc-group-name
        state: present
        auth_client_id: admin-cli
        auth_keycloak_url: https://auth.example.com/auth
        auth_realm: master
        auth_username: USERNAME
        auth_password: PASSWORD
      delegate_to: localhost

    - name: Create a keycloak group with some custom attributes
      keycloak_group:
        auth_client_id: admin-cli
        auth_keycloak_url: https://auth.example.com/auth
        auth_realm: master
        auth_username: USERNAME
        auth_password: PASSWORD
        name: my-new_group
        attributes:
            attrib1: value1
            attrib2: value2
            attrib3:
                - with
                - numerous
                - individual
                - list
                - items
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
group complex | always | Group representation of the group after module execution (sample is truncated).
| access dictionary | always | A dict describing the accesses you have to this group based on the credentials used. Sample: {'manage': True, 'manageMembership': True, 'view': True}
| attributes dictionary | always | Attributes applied to this group Sample: {'attr1': ['val1', 'val2', 'val3']}
| clientRoles list | always | A list of client-level roles granted to this group
| id string | always | GUID that identifies the group Sample: 23f38145-3195-462c-97e7-97041ccea73e
| name string | always | Name of the group Sample: grp-test-123
| path string | always | URI path to the group Sample: /grp-test-123
| realmRoles list | always | An array of the realm-level roles granted to this group
| subGroups list | always | A list of groups that are children of this group. These groups will have the same parameters as documented here.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Adam Goossens (@adamgoossens)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.